package env;

public class Bind<Key, Value> extends Env<Key, Value> {

  // A binding in an environment. Used in the parser to hold
  // synthesized values.

  private Key key;
  private Value value;

  public Bind(Key key, Value value) {
	super();
	this.key = key;
	this.value = value;
  }

  public Key getKey() {
	return key;
  }

  public void setKey(Key key) {
	this.key = key;
  }

  public Value getValue() {
	return value;
  }

  public void setValue(Value value) {
	this.value = value;
  }

  public Value lookup(Key key) {
	if (key.equals(this.key))
	  return value;
	else
	  return null;
  }

  public String toString() {
	return key + " = " + value;
  }

}
