package env;

public abstract class Env<Key, Value> {

  // An environment binds keys to values. It is used in the parser
  // to associate names with synthesized values.

  public abstract Value lookup(Key key);

  public Env<Key, Value> bind(Key key, Value value) {
	return new Pair<Key, Value>(new Bind<Key, Value>(key, value), this);
  }
}
