package env;

public class Pair<Key, Value> extends Env<Key, Value> {

  // Environments are concatenated together. The left-hand
  // environment takes precendence when looking up keys.

  private Env<Key, Value> left;
  private Env<Key, Value> right;

  public Pair(Env<Key, Value> left, Env<Key, Value> right) {
	super();
	this.left = left;
	this.right = right;
  }

  public Env<Key, Value> getLeft() {
	return left;
  }

  public void setLeft(Env<Key, Value> left) {
	this.left = left;
  }

  public Env<Key, Value> getRight() {
	return right;
  }

  public void setRight(Env<Key, Value> right) {
	this.right = right;
  }

  public Value lookup(Key key) {
	Value value = left.lookup(key);
	if (value != null)
	  return value;
	else
	  return right.lookup(key);
  }

  public String toString() {
	return left + " + " + right;
  }

}
