package parse;

import xcore.Value;
import env.Env;

public class And extends Parser {

  // An And-parser joins two parser together. The first sub-parser
  // is performed and the value os thrown away. If the first succeeds
  // then the second is performed.

  private Parser first;
  private Parser second;

  public And(Parser first, Parser second) {
	super();
	this.first = first;
	this.second = second;
  }

  public Parser getFirst() {
	return first;
  }

  public void setFirst(Parser first) {
	this.first = first;
  }

  public Parser getSecond() {
	return second;
  }

  public void setSecond(Parser second) {
	this.second = second;
  }

  public TagProcessor parse(final Grammar grammar, final Success s, Env<String, Value> env, final Fail c, Fail f) {
	// Try the first, if it succeeds then try the second...
	Success success = new Success() {
	  public TagProcessor success(Object value, Env<String, Value> env, Fail fail) {
		return second.parse(grammar, s, env, c, c);
	  }
	};
	return first.parse(grammar, success, env, c, f);
  }

}
