package parse;

import xcore.Str;
import xcore.Value;
import env.Env;

public class Bind extends Parser {

  // Try the parser and bind the result to the name.

  private String name;
  private Parser parser;

  public Bind(Str name, Parser parser) {
	super();
	this.name = name.getValue();
	this.parser = parser;
  }

  public String getName() {
	return name;
  }

  public void setName(String name) {
	this.name = name;
  }

  public Parser getParser() {
	return parser;
  }

  public void setParser(Parser parser) {
	this.parser = parser;
  }

  public TagProcessor parse(Grammar grammar, final Success s, final Env<String, Value> env, final Fail c, Fail f) {
	Success success = new Success() {
	  public TagProcessor success(Object value, Env<String, Value> env, Fail fail) {
		return s.success(value, env.bind(name, (Value) value), fail);
	  }
	};
	return parser.parse(grammar, success, env, c, f);
  }

}
