package parse;

import org.xml.sax.Attributes;

import xcore.Value;
import env.Env;

public class Or extends Parser {

  // A choice point...

  private Parser left;
  private Parser right;

  public Or(Parser left, Parser right) {
	super();
	this.left = left;
	this.right = right;
  }

  public Parser getLeft() {
	return left;
  }

  public void setLeft(Parser left) {
	this.left = left;
  }

  public Parser getRight() {
	return right;
  }

  public void setRight(Parser right) {
	this.right = right;
  }

  public TagProcessor parse(final Grammar grammar, final Success s, final Env<String, Value> env, final Fail c, final Fail f) {

	// Try the left hand option and add the right hand option to the
	// current fail. If the parse ever fails then the right hand option
	// will be tried...

	Fail fail = new Fail() {
	  public TagProcessor fail(String tag, Attributes attributes, Boolean isStart) {
		return right.parse(grammar, s, env, c, f).processTag(tag, attributes, isStart);
	  }
	};
	return left.parse(grammar, s, env, c, fail);
  }

}
