package parse;

import xcore.Value;
import xcore.Walker;
import env.Env;

public abstract class Parser extends Value {

  // A parser processes an XML tree and synthesizes a value.
  // The parse method is called with a grammar, a success (what to
  // do next), an environment binding variables to values and two
  // fails. The first fail is used to encode the options for a
  // single element, the second fail is used to encode the options
  // for parsing its children (the options cannot be confused).

  public abstract TagProcessor parse(Grammar grammar, Success s, Env<String, Value> env, Fail c, Fail f);

  public void walk(Walker walker) {
	throw new Error("Parser.ealker not implemented.");
  }
}
