package parse;

import org.xml.sax.Attributes;

import xcore.Cons;
import xcore.List;
import xcore.Nil;
import xcore.Value;
import env.Env;

public class Star extends Parser {

  // A Star parser greedily repeatedly tries its parser (including 0 times)
  // and returns a list of the synthesized results.

  private Parser parser;

  public Star(Parser parser) {
	super();
	this.parser = parser;
  }

  public TagProcessor parse(final Grammar grammar, final Success s, final Env<String, Value> env, final Fail c, final Fail f) {

	// Try using the parser, if it succeeds go round again. If it fails
	// then just return the empty list...

	Success success = new Success() {
	  public TagProcessor success(final Object value, Env<String, Value> env, Fail fail) {
		Success success = new Success() {
		  @SuppressWarnings("unchecked")
          public TagProcessor success(Object values, Env<String, Value> env, Fail fail) {
			List<Value> list = (List<Value>) values;
			return s.success(new Cons<Value>((Value) value, list), env, fail);
		  }
		};
		return Star.this.parse(grammar, success, env, c, f);
	  }
	};
	Fail fail = new Fail() {
	  public TagProcessor fail(String tag, Attributes attributes, Boolean isStart) {
		return s.success(new Nil<Value>(), env, c).processTag(tag, attributes, isStart);
	  }
	};
	return parser.parse(grammar, success, env, c, fail);
  }

  public Parser getParser() {
	return parser;
  }

  public void setParser(Parser parser) {
	this.parser = parser;
  }

}
