package parse;

import xcore.Str;
import xcore.Value;
import env.Env;

public class VarRef extends Parser {

  // A reference to a variable just synthesizes its value...

  private String name;

  public VarRef(Str name) {
	this.name = name.getValue();
  }

  public TagProcessor parse(Grammar grammar, Success s, Env<String, Value> env, Fail c, Fail f) {
	Value value = env.lookup(name);
	if (value == null)
	  throw new Error("Unbound var " + name);
	return s.success(value, env, f);
  }

  public String getName() {
	return name;
  }

  public void setName(String name) {
	this.name = name;
  }

}
