package xcore;

import java.util.Collection;

public class Cons<T extends Value> extends List<T> {

  // A cons-pair of type T...

  private T head;
  private List<T> tail;

  public Cons(T head, List<T> tail) {
	super();
	this.head = head;
	this.tail = tail;
  }

  public T getHead() {
	return head;
  }

  public void setHead(T head) {
	this.head = head;
  }

  public List<T> getTail() {
	return tail;
  }

  public void setTail(List<T> tail) {
	this.tail = tail;
  }

  public String toString() {
	return "[ " + head + "," + tail + "]";
  }

  public boolean isEmpty() {
	return false;
  }

  public boolean add(T e) {
	throw new Error("add not implemented");
  }

  public void add(int index, T element) {
	throw new Error("add not implemented");
  }

  public boolean addAll(Collection<? extends T> c) {
	throw new Error("add all not implemented");
  }

  public boolean addAll(int index, Collection<? extends T> c) {
	throw new Error("add all not implemented");
  }

  public void clear() {
	throw new Error("clear not implemented");
  }

  public boolean contains(Object o) {
	if (o == head)
	  return true;
	else
	  return tail.contains(o);
  }

  @SuppressWarnings("unchecked")
  public boolean containsAll(Collection<?> c) {
	boolean containsAll = true;
	for (Value x : (Collection<Value>) c)
	  containsAll = containsAll && contains(x);
	return containsAll;
  }

  public T get(int i) {
	if (i == 0)
	  return head;
	else
	  return tail.get(i - 1);
  }

  public int indexOf(Object o) {
	if (o == head)
	  return 0;
	else {
	  int indexOf = tail.indexOf(o);
	  if (indexOf == -1)
		return -1;
	  else
		return indexOf + 1;
	}
  }

  public boolean remove(Object o) {
	throw new Error("remove not implemented.");
  }

  public T remove(int index) {
	throw new Error("remove not implemented.");
  }

  public boolean removeAll(Collection<?> c) {
	throw new Error("removeAll not implemented.");
  }

  public boolean retainAll(Collection<?> c) {
	throw new Error("retainAll not implemented.");
  }

  public T set(int index, T element) {
	throw new Error("set not implemented.");
  }

  public int size() {
	return 1 + tail.size();
  }

  public java.util.List<T> subList(int fromIndex, int toIndex) {
	throw new Error("sublist not implemented.");
  }

  public Object[] toArray() {
	Object[] array = new Object[size()];
	int i = 0;
	for (T t : this)
	  array[i++] = t;
	return array;
  }

  @SuppressWarnings("unchecked")
  public <X> X[] toArray(X[] a) {
	int i = 0;
	for (T t : this)
	  a[i++] = (X) t;
	return a;
  }

}
