package xcore;

import java.util.Hashtable;

public class IdBuilder extends Walker {

  // Objects have a pseudo-attribute 'id' that is used for references
  // in XML trees in order to create cycles. The IdBuilder extracts the
  // id from the objects into a table which is then used to resolve refs.

  private Hashtable<String, ValueWithId> table = new Hashtable<String, ValueWithId>();

  public Hashtable<String, ValueWithId> getTable() {
	return table;
  }

  public void walk(Bool bool) {
  }

  public void walk(Cons<Value> cons) {
	walk(cons.getHead());
	walk(cons.getTail());
  }

  public void walk(Float f) {
  }

  public void walk(Int i) {
  }

  public void walk(Nil<Value> nil) {
  }

  public void walk(Obj obj) {
	table.put(obj.getId(), obj);
	walk(obj.getType());
	for (Slot s : obj.getSlots()) {
	  walk(s);
	}
  }

  public void walk(Ref ref) {
  }

  public void walk(Str str) {
  }

  public void rewalk(Value value) {
  }

  public void walk(Slot slot) {
	walk(slot.getValue());
  }

  public void mark(Value v, int i) {
  }

}
