package xcore;

import java.util.Iterator;

public abstract class List<T extends Value> extends Value implements java.util.List<T> {

  // A list of values (sub-classes buy cons and nil)...

  @SuppressWarnings("hiding")
  private class ListIterator<T extends Value> implements Iterator<T> {

	private List<T> list;
	private int i = 0;

	public ListIterator(List<T> list) {
	  this.list = list;
	}

	public boolean hasNext() {
	  return i < list.size();
	}

	public T next() {
	  return list.get(i++);
	}

	public void remove() {
	  throw new Error("Not implemented.");
	}

  }

  public static <T extends Value> List<T> cons(T[] array) {
	List<T> list = new Nil<T>();
	for (int i = array.length - 1; i >= 0; i--)
	  list = new Cons<T>(array[i], list);
	return list;
  }

  public abstract boolean isEmpty();

  public boolean isNotEmpty() {
	return !isEmpty();
  }

  public Iterator<T> iterator() {
	return new ListIterator<T>(this);
  }

  public int lastIndexOf(Object arg0) {
	return -1;
  }

  public java.util.ListIterator<T> listIterator() {
	throw new Error("Cannot create list iterator.");
  }

  public java.util.ListIterator<T> listIterator(int arg0) {
	throw new Error("Cannot create list iterator.");
  }

}
