package xcore;

import java.util.Hashtable;

public class Mark extends Walker {

  // Used to mark cycles with ids to be used as a label in
  // the printer...

  private Hashtable<Value, Integer> marks = new Hashtable<Value, Integer>();

  private int counter = 0;

  private void mark(Value value) {
	marks.put(value, counter++);
  }

  public int getMark(Value value) {
	if (marks.containsKey(value))
	  return marks.get(value);
	else
	  return -1;
  }

  public void rewalk(Value value) {
  }

  public void walk(Bool bool) {
  }

  public void walk(Cons<Value> cons) {
	mark(cons);
	walk(cons.getHead());
	walk(cons.getTail());
  }

  public void walk(Float f) {
  }

  public void walk(Int i) {
  }

  public void walk(Nil<Value> nil) {
  }

  public void walk(Obj obj) {
	mark(obj);
	walk(obj.getType());
	for (Slot s : obj.getSlots())
	  walk(s);
  }

  public void walk(Ref ref) {
  }

  public void walk(Slot slot) {
  }

  public void walk(Str str) {
  }

  public void mark(Value v, int i) {
  }

}
