package xcore;

import java.util.Collection;

public class Nil<T extends Value> extends List<T> {

  // Empty list...

  public boolean isEmpty() {
	return true;
  }

  public boolean add(T arg0) {
	return false;
  }

  public void add(int arg0, T arg1) {
	throw new Error("Cannot add element to Nil");
  }

  public boolean addAll(Collection<? extends T> arg0) {
	return false;
  }

  public boolean addAll(int arg0, Collection<? extends T> arg1) {
	return false;
  }

  public void clear() {
  }

  public boolean contains(Object arg0) {
	return false;
  }

  public boolean containsAll(Collection<?> arg0) {
	return false;
  }

  public T get(int arg0) {
	throw new Error("Nil cannot get " + arg0);
  }

  public int indexOf(Object arg0) {
	return -1;
  }

  public boolean remove(Object arg0) {
	return false;
  }

  public T remove(int arg0) {
	return null;
  }

  public boolean removeAll(Collection<?> arg0) {
	return false;
  }

  public boolean retainAll(Collection<?> arg0) {
	return false;
  }

  public T set(int arg0, T arg1) {
	throw new Error("Cannot set element");
  }

  public int size() {
	return 0;
  }

  public java.util.List<T> subList(int arg0, int arg1) {
	throw new Error("Cannot create sublist");
  }

  public Object[] toArray() {
	return new Object[0];
  }

  @SuppressWarnings("hiding")
  public <T> T[] toArray(T[] arg0) {
	return arg0;
  }

}
