package xcore;

import java.util.Vector;

public class Obj extends ValueWithId {
  
  // A simple object...

  private Vector<Slot> slots = new Vector<Slot>();

  public Obj(Str id, Value type, List<Slot> slots) {
	setId(id.getValue());
	setType(type);
	for (Slot slot : slots)
	  this.slots.addElement(slot);
  }

  public void addSlot(Slot o) {
	slots.addElement(o);
  }

  public void addSlot(String name, Value value) {
	slots.addElement(new Slot(new Str(name), value));
  }

  public Value get(String name) {
	for (Slot s : slots) {
	  if (s.getName().equals(name))
		return s.getValue();
	}
	return null;
  }

  public Vector<Slot> getSlots() {
	return slots;
  }

  public void setSlots(Vector<Slot> slots) {
	this.slots = slots;
  }

  public String toString() {
	String s = "(" + getType() + ")[";
	for (Slot slot : slots) {
	  s = s + slot.getName() + "=" + slot.getValue();
	  if (slots.lastElement() != slot)
		s = s + ",";
	}
	return s + "]";
  }

}
