package xcore;

import java.util.Hashtable;

public class Resolver extends Walker {

  // Deals with cross references in an XML tree..

  private Hashtable<String, ValueWithId> table;

  public Resolver(Hashtable<String, ValueWithId> hashtable) {
	this.table = hashtable;
  }

  public void rewalk(Value value) {
  }

  public void walk(Bool bool) {
  }

  public boolean isRef(Value value) {
	return value instanceof Ref;
  }

  public void walk(Cons<Value> cons) {
	if (isRef(cons.getHead()))
	  cons.setHead(resolve((Ref) cons.getHead()));
	walk(cons.getHead());
	walk(cons.getTail());
  }

  private Value resolve(Ref ref) {
	if (table.containsKey(ref.getId()))
	  return table.get(ref.getId());
	else
	  throw new Error("Cannot resolve ref: " + ref.getId());
  }

  public void walk(Float f) {
  }

  public void walk(Int i) {
  }

  public void walk(Nil<Value> nil) {
  }

  public void walk(Obj obj) {
	if (isRef(obj.getType()))
	  obj.setType(resolve((Ref) obj.getType()));
	walk(obj.getType());
	for (Slot s : obj.getSlots()) {
	  walk(s);
	}
  }

  public void walk(Ref ref) {
	throw new Error("Not expecting a reference in resolver at this point.");
  }

  public void walk(Str str) {
  }

  public void walk(Slot s) {
	if (isRef(s.getValue()))
	  s.setValue(resolve((Ref) s.getValue()));
	walk(s.getValue());
  }

  public void mark(Value v, int i) {
  }

}
